﻿using System;
using System.IO;

namespace RemplazaCaracteres
{
    class Program
    {
        static void Main(string[] args)
        {
            string strPath = string.Empty,
                strOldString = string.Empty,
                strNewString = string.Empty;

            Console.WriteLine("Remplaza caracteres o cadenas en nombres de archivos sin tomar en cuenta la extensión");
            Console.WriteLine("Ingresa ruta de carpeta: ");
            strPath = Console.ReadLine();


            Console.WriteLine("Ingresa el caracter o texto a remplazar: ");
            strOldString = Console.ReadLine();

            Console.WriteLine("Ingresa el caracter o texto con el que se remplazara:");
            strNewString = Console.ReadLine();


            string[] aryFiles = Directory.GetFiles(strPath),
                aryNewNameFiles = new string[aryFiles.Length];

            
            aryNewNameFiles = QuitaPath(aryFiles, strPath);

            aryNewNameFiles = RemplazaCaracter(aryNewNameFiles, strOldString, strNewString);

            aryNewNameFiles = AgregaPath(aryNewNameFiles, strPath);

            for(int i = 0; i<aryFiles.Length;i++)
            {
                File.Move(aryFiles[i], aryNewNameFiles[i]);
            }

        }


        static string[] QuitaPath(string [] aryFiles,string strPath)
        {
            string[] aryString = new string [aryFiles.Length];

            for(int i= 0; i < aryString.Length;i++ )
            {
                aryString[i] = aryFiles[i].Replace(strPath + "\\", " ").Trim();
                Console.WriteLine(aryString[i]);
            }

            return aryString;
        }

        static string[] AgregaPath(string[] aryFiles, string strPath)
        {
            string[] aryString = new string[aryFiles.Length];

            for (int i = 0; i < aryString.Length; i++)
            {
                aryString[i] = strPath + "\\" + aryFiles[i];
                Console.WriteLine(aryString[i]);
            }

            return aryString;
        }


        static string[] RemplazaCaracter(string[] aryFiles, string strOldString, string strNewString)
        {
            string[] aryString = new string[aryFiles.Length];

            string strExtFile = string.Empty;

            int nStartPos = 0,
                nEndPos = 0,
                nLengthString = 0;

            for (int i = 0; i < aryString.Length; i++)
            {
                strExtFile = "";
                nStartPos = 0;
                nEndPos = 0;
                nLengthString = 0;

                nStartPos = aryFiles[i].IndexOf('.');
                nEndPos = aryFiles[i].Length;
                nLengthString = nEndPos - nStartPos;

                strExtFile = aryFiles[i].Substring(nStartPos, nLengthString);

                aryString[i] = aryFiles[i].Replace(strExtFile," ").Trim();

                if(strNewString.Contains(" "))
                {
                    strNewString = string.Empty;
                }

                aryString[i] = aryString[i].Replace(strOldString, strNewString).Trim();

                aryString[i] = aryString[i] + strExtFile;
                Console.WriteLine(aryString[i]);
            }

            return aryString;
        }

    }
}
